#
# spec file for package glib2
#
# Copyright (c) 2011 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild

%define with_systemtap 0

Name:           glib2
%define _name glib
Version:        2.27.91
Release:        1
# FIXME: change zlib-devel to pkgconfig(zlib) once we have a recent enough version of zlib
# FIXME: find out if tapsets should really be in devel package or in main package
License:        LGPLv2+
Summary:        General-Purpose Utility Library
Url:            http://www.gtk.org/
Group:          System/Libraries
Source:         ftp://ftp.gnome.org/pub/GNOME/sources/%{_name}/2.14/%{_name}-%{version}.tar.bz2
Source1:        glib2.sh
Source2:        glib2.csh
Source3:        SuSEconfig.glib2
# Not upsteam file. Only proposes upstream packages:
Source4:        glib2-upstream-gnome_defaults.conf
Source5:        macros.glib2
# Not depending on gtk-doc shortens bootstrap compilation path.
# Please update this file from the latest gtk-doc package:
Source6:        gtk-doc.m4
Source99:       baselibs.conf
# PATCH-FIX-OPENSUSE glib2-bnc379332-desktop-su.patch bnc379332 vuntz@novell.com -- Use X-KDE-SubstituteUID
Patch8:         glib2-bnc379332-desktop-su.patch
# PATCH-FEATURE-UPSTREAM glib2-bgo569829-gettext-gkeyfile.patch fate300461 bgo569829 vuntz@novell.com -- Look for translation of desktop entry strings via gettext, part that we share with Ubuntu and try to push upstream
Patch10:        glib2-bgo569829-gettext-gkeyfile.patch
# PATCH-FEATURE-OPENSUSE glib2-fate300461-gettext-gkeyfile-suse.patch fate300461 vuntz@novell.com -- Look for translation of desktop entry strings via gettext, part that deals with the openSUSE specific infrastructure (with desktop_translations)
Patch11:        glib2-fate300461-gettext-gkeyfile-suse.patch
BuildRequires:  fam-devel
BuildRequires:  fdupes
BuildRequires:  gcc-c++
BuildRequires:  libselinux-devel
BuildRequires:  pkg-config
%if 0%{?with_systemtap}
# systemtap-sdt-devel on openSUSE 11.3 was missing a Requires: python.
%if %{?suse_version} <= 1130
BuildRequires:  python
%endif
BuildRequires:  systemtap-sdt-devel
%endif
BuildRequires:  translation-update-upstream
BuildRequires:  zlib-devel
BuildRequires:  pkgconfig(libpcre)
%if 0%{?BUILD_FROM_VCS}
# It's important to keep those BuildRequires inside
# BUILD_FROM_VCS to avoid build loops in Factory
BuildRequires:  git-core
BuildRequires:  gtk-doc
%endif
# For temporary %%posttrans script only.
PreReq:         coreutils
PreReq:         /bin/sed
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
GLib is a general-purpose utility library, which provides many useful
data types, macros, type conversions, string utilities, file utilities,
a main loop abstraction, and so on.

%package tools
License:        LGPLv2+
Summary:        General-Purpose Utility Library -- Tools
Group:          Development/Libraries/C and C++

%description tools
GLib is a general-purpose utility library, which provides many useful
data types, macros, type conversions, string utilities, file utilities,
a main loop abstraction, and so on.

%package branding-upstream
License:        LGPLv2+
Summary:        Definition of GNOME Default Applications
Group:          System/Libraries
Provides:       %{name}-branding = %{version}
Conflicts:      otherproviders(%{name}-branding)
Supplements:    packageand(%{name}:branding-upstream)
#BRAND: The /etc/gnome_defaults.conf allows to define arbitrary
#BRAND: applications as preferred defaults.
# NOTE: gnome_defaults is not an upstream feature, but a SuSE
# enhancement, but to conform branding conventions, the package is named
# as glib2-branding-upstream.

%description branding-upstream
This branding-style package sets default applications in GNOME in
openSUSE.

This is a dumb package, which provides only upstream GNOME packages as
preferred defaults. You most probably don't want this package. You
probably want to install distribution default glib2-branding and prefer
distribution wise GNOME defaults.

%package devel
#'
License:        LGPLv2+
Requires:       %{name} = %{version} pkg-config glibc-devel
# Now require the subpackages too
Requires:       glib2-tools = %{version}
Requires:       libglib-2_0-0 = %{version}
Requires:       libgmodule-2_0-0 = %{version}
Requires:       libgio-2_0-0 = %{version}
Requires:       libgthread-2_0-0 = %{version}
Requires:       libgobject-2_0-0 = %{version}
Provides:       glib2-doc = 2.19.6
Obsoletes:      glib2-doc < 2.19.6
Summary:        General-Purpose Utility Library -- Development Files
Group:          Development/Libraries/C and C++
# bug437293
%ifarch ppc64
Obsoletes:      glib2-devel-64bit
%endif
#

%description devel
GLib is a general-purpose utility library, which provides many useful
data types, macros, type conversions, string utilities, file utilities,
a main loop abstraction, and so on.

This package contains the development files for GLib.

%package devel-static
License:        LGPLv2+
Requires:       %{name}-devel = %{version}
Summary:        General-Purpose Utility Library -- Static Libraries
Group:          Development/Libraries/C and C++

%description devel-static
GLib is a general-purpose utility library, which provides many useful
data types, macros, type conversions, string utilities, file utilities,
a main loop abstraction, and so on.

This package contains static versions of the GLib libraries.

%package -n libglib-2_0-0
License:        LGPLv2+
Summary:        General-Purpose Utility Library
Group:          System/Libraries
Requires:       %{name}-branding = %{version}
Recommends:     %{name}-lang = %{version}
Provides:       %{name} = %{version}
Obsoletes:      %{name} < %{version}
# bug437293
%ifarch ppc64
Obsoletes:      glib2-64bit
%endif
#

%description -n libglib-2_0-0
GLib is a general-purpose utility library, which provides many useful
data types, macros, type conversions, string utilities, file utilities,
a main loop abstraction, and so on.

%package -n libgmodule-2_0-0
License:        LGPLv2+
Summary:        General-Purpose Utility Library -- Library for Modules
Group:          System/Libraries

%description -n libgmodule-2_0-0
GLib is a general-purpose utility library, which provides many useful
data types, macros, type conversions, string utilities, file utilities,
a main loop abstraction, and so on.

The libgmodule library provides a portable way to dynamically load
object files (commonly known as 'plug-ins').

%package -n libgio-2_0-0
License:        LGPLv2+
Summary:        General-Purpose Utility Library -- Library for VFS
Group:          System/Libraries
# bnc#555605: shared-mime-info is required by libgio to properly detect mime types.
Requires:       shared-mime-info
# The tools are useful for people having libgio
Recommends:     %{name}-tools
# Temporarily disable this, pending further discussion
# Recommends:     gvfs

%description -n libgio-2_0-0
GLib is a general-purpose utility library, which provides many useful
data types, macros, type conversions, string utilities, file utilities,
a main loop abstraction, and so on.

GIO provides a modern, easy-to-use VFS API.

%package -n libgio-fam
License:        LGPLv2+
Summary:        General-Purpose Utility Library -- GIO Module to use FAM
Group:          System/Libraries
# we need gio-querymodules in %post/%postun
Requires(post): %{name}-tools
Requires(postun): %{name}-tools
Supplements:    packageand(libgio-2_0-0:fam)

%description -n libgio-fam
GLib is a general-purpose utility library, which provides many useful
data types, macros, type conversions, string utilities, file utilities,
a main loop abstraction, and so on.

This packages provides a GIO module to use FAM for file monitoring.

%package -n libgthread-2_0-0
License:        LGPLv2+
Summary:        General-Purpose Utility Library -- Library for Threads
Group:          System/Libraries

%description -n libgthread-2_0-0
GLib is a general-purpose utility library, which provides many useful
data types, macros, type conversions, string utilities, file utilities,
a main loop abstraction, and so on.

The libgthread library provides a portable way to write multi-threaded
software.

%package -n libgobject-2_0-0
License:        LGPLv2+
Summary:        General-Purpose Utility Library -- Object-Oriented Framework for C
Group:          System/Libraries

%description -n libgobject-2_0-0
GLib is a general-purpose utility library, which provides many useful
data types, macros, type conversions, string utilities, file utilities,
a main loop abstraction, and so on.

The GObject library provides an object-oriented framework for C.

%lang_package
%prep
%setup -q -n %{_name}-%{version}
translation-update-upstream
%patch8
%patch10 -p1
%patch11 -p1
cp -a %{S:1} %{S:2} %{S:3} .
cp -a %{S:4} gnome_defaults.conf
if ! test -f %{_datadir}/aclocal/gtk-doc.m4 ; then
    cp -a %{S:6} m4macros/
fi
%if 0%{?BUILD_FROM_VCS}
NOCONFIGURE=1 ./autogen.sh
%endif

%build
%configure \
    --enable-static \
    --enable-selinux \
    --with-pcre=system \
%if 0%{?with_systemtap}
    --enable-systemtap \
%endif
%if 0%{?BUILD_FROM_VCS}
    --enable-gtk-doc \
%endif
    --with-runtime-libdir=../../%{_lib}
%{__make} %{?_smp_mflags}
%if 0%{?BUILD_FROM_VCS}
%{__make} ChangeLog
%endif

%check
# make check does not work on x86_64. See http://bugzilla.gnome.org/show_bug.cgi?id=554969
# %{__make} %{?jobs:-j%jobs} check

%install
%makeinstall
%if 0%{?suse_version} <= 1120
%{__rm} %{buildroot}%{_datadir}/locale/en@shaw/LC_MESSAGES/*
%endif
%find_lang %{_name}20
mkdir -p %{buildroot}%{_sysconfdir}/profile.d
install -D -m0644 glib2.sh %{buildroot}%{_sysconfdir}/profile.d/zzz-glib2.sh
install -D -m0644 glib2.csh %{buildroot}%{_sysconfdir}/profile.d/zzz-glib2.csh
install -D -m0755 SuSEconfig.glib2 %{buildroot}/sbin/conf.d/SuSEconfig.glib2
install -D -m0644 gnome_defaults.conf %{buildroot}%{_sysconfdir}/gnome_defaults.conf
# default apps magic
mkdir -p %{buildroot}%{_localstatedir}/cache/gio-2.0 %{buildroot}%{_datadir}/applications
touch %{buildroot}%{_localstatedir}/cache/gio-2.0/defaults.list
ln -s %{_localstatedir}/cache/gio-2.0/defaults.list %{buildroot}%{_datadir}/applications/defaults.list
# gio-querymodules magic
%if "%{_lib}" == "lib64"
mv %{buildroot}%{_bindir}/gio-querymodules %{buildroot}%{_bindir}/gio-querymodules-64
%endif
touch %{buildroot}%{_libdir}/gio/modules/giomodule.cache
# gsettings magic
touch %{buildroot}%{_datadir}/glib-2.0/schemas/gschemas.compiled
# remove files we don't care about
find %{buildroot}%{_libdir} -name '*.la' -type f -delete -print
rm %{buildroot}%{_libdir}/gio/modules/libgiofam.a
# Install rpm macros
mkdir -p %{buildroot}%{_sysconfdir}/rpm
cp %{S:5} %{buildroot}%{_sysconfdir}/rpm
%fdupes %{buildroot}

%posttrans
# If it is an upgrade and gnome_defaults.conf were edited,
# move it from its old location. (Upgrade from <= 10.2)
if test -f etc/opt/gnome/gnome_defaults.conf.rpmsave ; then
    mv etc/gnome_defaults.conf etc/gnome_defaults.conf.rpmnew
    sed "s:etc/opt/gnome:etc:g;s:opt/gnome:usr:g" <etc/opt/gnome/gnome_defaults.conf.rpmsave >etc/gnome_defaults.conf
fi
# If it is an upgrade and gnome_defaults.conf were edited,
# revive it from the RPM backup. (Upgrade from == 10.3)
if test -f etc/gnome_defaults.conf.rpmsave ; then
    mv etc/gnome_defaults.conf etc/gnome_defaults.conf.rpmnew
    mv etc/gnome_defaults.conf.rpmsave etc/gnome_defaults.conf
fi

%post -n libglib-2_0-0 -p /sbin/ldconfig

%post -n libgobject-2_0-0 -p /sbin/ldconfig

%post -n libgthread-2_0-0 -p /sbin/ldconfig

%post -n libgio-2_0-0 -p /sbin/ldconfig

%post -n libgmodule-2_0-0 -p /sbin/ldconfig

%post -n libgio-fam
%if 0
###############################################################################
# Note: when updating this scriptlet, don't forget to also update baselibs.conf
###############################################################################
%endif
%if "%{_lib}" == "lib64"
  %{_bindir}/gio-querymodules-64 %{_libdir}/gio/modules
%else
  %{_bindir}/gio-querymodules %{_libdir}/gio/modules
%endif

%postun -n libglib-2_0-0 -p /sbin/ldconfig

%postun -n libgobject-2_0-0 -p /sbin/ldconfig

%postun -n libgthread-2_0-0 -p /sbin/ldconfig

%postun -n libgio-2_0-0 -p /sbin/ldconfig

%postun -n libgmodule-2_0-0 -p /sbin/ldconfig

%postun -n libgio-fam
%if 0
###############################################################################
# Note: when updating this scriptlet, don't forget to also update baselibs.conf
###############################################################################
%endif
%if "%{_lib}" == "lib64"
  %{_bindir}/gio-querymodules-64 %{_libdir}/gio/modules
%else
  %{_bindir}/gio-querymodules %{_libdir}/gio/modules
%endif

%clean
rm -rf %{buildroot}

%files tools
%defattr(-,root,root)
%{_sysconfdir}/bash_completion.d/gdbus-bash-completion.sh
%{_sysconfdir}/bash_completion.d/gsettings-bash-completion.sh
%{_bindir}/gdbus
%{_bindir}/gio-querymodules*
%{_bindir}/glib-compile-schemas
%{_bindir}/gsettings
%{_mandir}/man1/gdbus.1*
%{_mandir}/man1/gio-querymodules.1*
%{_mandir}/man1/glib-compile-schemas.1*
%{_mandir}/man1/gsettings.1*
# We put those files here, but they don't really belong here. They just don't
# have a better home... The zzz-glib2 scripts could arguably be in
# libglib-2_0-0 but that would break the shared library policy.
%{_sysconfdir}/profile.d/zzz-glib2.*
/sbin/conf.d/SuSEconfig.glib2

%files branding-upstream
%defattr(-,root,root)
%config (noreplace) %{_sysconfdir}/gnome_defaults.conf

%files -n libglib-2_0-0
%defattr(-, root, root)
%doc AUTHORS COPYING README NEWS ChangeLog
/%{_lib}/libglib*.so.*

%files -n libgmodule-2_0-0
%defattr(-, root, root)
/%{_lib}/libgmodule*.so.*

%files -n libgobject-2_0-0
%defattr(-, root, root)
/%{_lib}/libgobject*.so.*

%files -n libgthread-2_0-0
%defattr(-, root, root)
/%{_lib}/libgthread*.so.*

%files -n libgio-2_0-0
%defattr(-, root, root)
/%{_lib}/libgio*.so.*
%dir %{_libdir}/gio
%dir %{_libdir}/gio/modules
%ghost %{_libdir}/gio/modules/giomodule.cache
%dir %{_datadir}/glib-2.0/
%dir %{_datadir}/glib-2.0/schemas/
%ghost %{_datadir}/glib-2.0/schemas/gschemas.compiled
%{_datadir}/applications/defaults.list
%dir %{_localstatedir}/cache/gio-2.0
%ghost %{_localstatedir}/cache/gio-2.0/defaults.list

%files -n libgio-fam
%defattr(-,root,root)
%{_libdir}/gio/modules/libgiofam.so

%files lang -f %{_name}20.lang

%files devel
%defattr(-,root,root)
%{_bindir}/glib-genmarshal
%{_bindir}/glib-gettextize
%{_bindir}/glib-mkenums
%{_bindir}/gobject-query
%{_bindir}/gtester
%{_bindir}/gtester-report
%doc %{_mandir}/man?/glib-genmarshal.*
%doc %{_mandir}/man?/glib-gettextize.*
%doc %{_mandir}/man?/glib-mkenums.*
%doc %{_mandir}/man?/gobject-query.*
%doc %{_mandir}/man?/gtester.*
%doc %{_mandir}/man?/gtester-report.*
%{_datadir}/aclocal/*.m4
%dir %{_datadir}/glib-2.0/
%{_datadir}/glib-2.0/gdb/
%{_datadir}/glib-2.0/gettext/
%{_datadir}/glib-2.0/schemas/gschema.dtd
%{_includedir}/glib-2.0
%{_includedir}/gio-unix-2.0
%{_libdir}/lib*.so
%dir %{_libdir}/glib-2.0/
%{_libdir}/glib-2.0/include/
%{_libdir}/pkgconfig/*.pc
%{_datadir}/gtk-doc/html/gio
%{_datadir}/gtk-doc/html/glib
%{_datadir}/gtk-doc/html/gobject
%{_datadir}/gdb/auto-load/%{_lib}/*-gdb.py
%if 0%{?with_systemtap}
%{_datadir}/systemtap/tapset/*.stp
%endif
%{_sysconfdir}/rpm/macros.glib2
# Own these directories to not depend on gtk-doc while building:
%dir %{_datadir}/gtk-doc
%dir %{_datadir}/gtk-doc/html
# Own these directories to not depend on gdb
%dir %{_datadir}/gdb
%dir %{_datadir}/gdb/auto-load
%dir %{_datadir}/gdb/auto-load/%{_lib}

%files devel-static
%defattr(-,root,root)
%{_libdir}/lib*.a

%changelog
